/**
 * \file rbc_poly.h
 * \brief Interface for polynomials over a finite field
 */

#ifndef RBC_POLY_H
#define RBC_POLY_H

#include "rbc.h"
#include "rbc_vspace.h"
#include "random_source.h"

{TEMPLATING_RBC_POLY_INIT}
{TEMPLATING_RBC_POLY_CLEAR}
{TEMPLATING_RBC_POLY_SPARSE_INIT}
{TEMPLATING_RBC_POLY_SPARSE_CLEAR}
{TEMPLATING_RBC_POLY_SET_ZERO}
{TEMPLATING_RBC_POLY_SET}
{TEMPLATING_RBC_POLY_SET_RANDOM}
{TEMPLATING_RBC_POLY_SET_RANDOM_FULL_RANK}
{TEMPLATING_RBC_POLY_SET_RANDOM_FULL_RANK_WITH_ONE}
{TEMPLATING_RBC_POLY_SET_RANDOM_FROM_SUPPORT}
{TEMPLATING_RBC_POLY_SET_RANDOM_PAIR_FROM_SUPPORT}
{TEMPLATING_RBC_POLY_IS_EQUAL_TO}
{TEMPLATING_RBC_POLY_ADD}
{TEMPLATING_RBC_POLY_MUL}
{TEMPLATING_RBC_POLY_MULMOD_SPARSE}
{TEMPLATING_RBC_POLY_INV}
{TEMPLATING_RBC_POLY_TO_STRING}
{TEMPLATING_RBC_POLY_FROM_STRING}
{TEMPLATING_RBC_POLY_PRINT}
{TEMPLATING_RBC_POLY_SPARSE_PRINT}
#endif

